## re2 0+hg40+dfsg

=== Makefile ===
# Copyright 2009 The RE2 Authors.  All Rights Reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

all: obj/libre2.a obj/so/libre2.so

# to build against PCRE for testing or benchmarking,
# uncomment the next two lines
# CCPCRE=-I/usr/local/include -DUSEPCRE
# LDPCRE=-L/usr/local/lib -lpcre

CC=g++
CXXFLAGS=-Wall -O3 -g -pthread  # can override
RE2_CXXFLAGS=-Wno-sign-compare -c -I. $(CCPCRE)  # required
LDFLAGS=-pthread
AR=ar
ARFLAGS=rsc
NM=nm
NMFLAGS=-p

# Variables mandated by GNU, the arbiter of all good taste on the internet.
# http://www.gnu.org/prep/standards/standards.html
prefix=/usr/local
exec_prefix=$(prefix)
bindir=$(exec_prefix)/bin
includedir=$(prefix)/include
libdir=$(exec_prefix)/lib
INSTALL=install
INSTALL_PROGRAM=$(INSTALL)
INSTALL_DATA=$(INSTALL) -m 644

# ABI version
# http://tldp.org/HOWTO/Program-Library-HOWTO/shared-libraries.html
SONAME=0

# To rebuild the Tables generated by Perl and Python scripts (requires Internet
# access for Unicode data), uncomment the following line:
# REBUILD_TABLES=1

ifeq ($(shell uname),Darwin)
MAKE_SHARED_LIBRARY=g++ -dynamiclib $(LDFLAGS) -exported_symbols_list libre2.symbols.darwin
else
MAKE_SHARED_LIBRARY=g++ -shared -Wl,-soname,libre2.so.0,--version-script=libre2.symbols $(LDFLAGS)
endif

INSTALL_HFILES=\
	re2/re2.h\
	re2/set.h\
	re2/stringpiece.h\
	re2/variadic_function.h\

HFILES=\
	util/arena.h\
	util/atomicops.h\
	util/benchmark.h\
	util/flags.h\
	util/hash_map.h\
	util/logging.h\
	util/mutex.h\
	util/pcre.h\
	util/random.h\
	util/sparse_array.h\
	util/sparse_set.h\
	util/test.h\
	util/utf.h\
	util/util.h\
	util/valgrind.h\
	re2/filtered_re2.h\
	re2/prefilter.h\
	re2/prefilter_tree.h\
	re2/prog.h\
	re2/re2.h\
	re2/regexp.h\
	re2/set.h\
	re2/stringpiece.h\
	re2/testing/exhaustive_tester.h\
	re2/testing/regexp_generator.h\
	re2/testing/string_generator.h\
	re2/testing/tester.h\
	re2/unicode_casefold.h\
	re2/unicode_groups.h\
	re2/variadic_function.h\
	re2/walker-inl.h\

OFILES=\
	obj/util/arena.o\
	obj/util/hash.o\
	obj/util/rune.o\
	obj/util/stringpiece.o\
	obj/util/stringprintf.o\
	obj/util/strutil.o\
	obj/util/valgrind.o\
	obj/re2/bitstate.o\
	obj/re2/compile.o\
	obj/re2/dfa.o\
	obj/re2/filtered_re2.o\
	obj/re2/mimics_pcre.o\
	obj/re2/nfa.o\
	obj/re2/onepass.o\
	obj/re2/parse.o\
	obj/re2/perl_groups.o\
	obj/re2/prefilter.o\
	obj/re2/prefilter_tree.o\
	obj/re2/prog.o\
	obj/re2/re2.o\
	obj/re2/regexp.o\
	obj/re2/set.o\
	obj/re2/simplify.o\
	obj/re2/tostring.o\
	obj/re2/unicode_casefold.o\
	obj/re2/unicode_groups.o\

TESTOFILES=\
	obj/util/pcre.o\
	obj/util/random.o\
	obj/util/thread.o\
	obj/re2/testing/backtrack.o\
	obj/re2/testing/dump.o\
	obj/re2/testing/exhaustive_tester.o\
	obj/re2/testing/null_walker.o\
	obj/re2/testing/regexp_generator.o\
	obj/re2/testing/string_generator.o\
	obj/re2/testing/tester.o\

TESTS=\
	obj/test/charclass_test\
	obj/test/compile_test\
	obj/test/filtered_re2_test\
	obj/test/mimics_pcre_test\
	obj/test/parse_test\
	obj/test/possible_match_test\
	obj/test/re2_test\
	obj/test/re2_arg_test\
	obj/test/regexp_test\
	obj/test/required_prefix_test\
	obj/test/search_test\
	obj/test/set_test\
	obj/test/simplify_test\
	obj/test/string_generator_test\

BIGTESTS=\
	obj/test/dfa_test\
	obj/test/exhaustive1_test\
	obj/test/exhaustive2_test\
	obj/test/exhaustive3_test\
	obj/test/exhaustive_test\
	obj/test/random_test\

SOFILES=$(patsubst obj/%,obj/so/%,$(OFILES))
STESTOFILES=$(patsubst obj/%,obj/so/%,$(TESTOFILES))
STESTS=$(patsubst obj/%,obj/so/%,$(TESTS))
SBIGTESTS=$(patsubst obj/%,obj/so/%,$(BIGTESTS))

DOFILES=$(patsubst obj/%,obj/dbg/%,$(OFILES))
DTESTOFILES=$(patsubst obj/%,obj/dbg/%,$(TESTOFILES))
DTESTS=$(patsubst obj/%,obj/dbg/%,$(TESTS))
DBIGTESTS=$(patsubst obj/%,obj/dbg/%,$(BIGTESTS))

obj/%.o: %.cc $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CC) -o $@ $(CXXFLAGS) $(RE2_CXXFLAGS) -DNDEBUG $*.cc

obj/dbg/%.o: %.cc $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CC) -o $@ -fPIC $(CXXFLAGS) $(RE2_CXXFLAGS) $*.cc

obj/so/%.o: %.cc $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CC) -o $@ -fPIC $(CXXFLAGS) $(RE2_CXXFLAGS) -DNDEBUG $*.cc

obj/%.o: %.c $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CC) -o $@ $(CXXFLAGS) $(RE2_CXXFLAGS) -DNDEBUG $*.c

obj/dbg/%.o: %.c $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CC) -o $@ $(CXXFLAGS) $(RE2_CXXFLAGS) $*.c

obj/so/%.o: %.c $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CC) -o $@ -fPIC $(CXXFLAGS) $(RE2_CXXFLAGS) -DNDEBUG $*.c

obj/libre2.a: $(OFILES)
	@mkdir -p obj
	$(AR) $(ARFLAGS) obj/libre2.a $(OFILES)

obj/dbg/libre2.a: $(DOFILES)
	@mkdir -p obj/dbg
	$(AR) $(ARFLAGS) obj/dbg/libre2.a $(DOFILES)

obj/so/libre2.so: $(SOFILES)
	@mkdir -p obj/so
	$(MAKE_SHARED_LIBRARY) -o $@.0 $(SOFILES)
	ln -sf libre2.so.0 $@

obj/test/%: obj/libre2.a obj/re2/testing/%.o $(TESTOFILES) obj/util/test.o
	@mkdir -p obj/test
	$(CC) -o $@ obj/re2/testing/$*.o $(TESTOFILES) obj/util/test.o obj/libre2.a $(LDFLAGS) $(LDPCRE)

obj/dbg/test/%: obj/dbg/libre2.a obj/dbg/re2/testing/%.o $(DTESTOFILES) obj/dbg/util/test.o
	@mkdir -p obj/dbg/test
	$(CC) -o $@ obj/dbg/re2/testing/$*.o $(DTESTOFILES) obj/dbg/util/test.o obj/dbg/libre2.a $(LDFLAGS) $(LDPCRE)

obj/so/test/%: obj/so/libre2.so obj/libre2.a obj/so/re2/testing/%.o $(STESTOFILES) obj/so/util/test.o
	@mkdir -p obj/so/test
	$(CC) -o $@ obj/so/re2/testing/$*.o $(STESTOFILES) obj/so/util/test.o -Lobj/so -lre2 obj/libre2.a $(LDFLAGS) $(LDPCRE)

obj/test/regexp_benchmark: obj/libre2.a obj/re2/testing/regexp_benchmark.o $(TESTOFILES) obj/util/benchmark.o
	@mkdir -p obj/test
	$(CC) -o $@ obj/re2/testing/regexp_benchmark.o $(TESTOFILES) obj/util/benchmark.o obj/libre2.a $(LDFLAGS) $(LDPCRE)

ifdef REBUILD_TABLES
re2/perl_groups.cc: re2/make_perl_groups.pl
	perl $< > $@

re2/unicode_%.cc: re2/make_unicode_%.py
	python $< > $@
endif

distclean: clean
	rm -f re2/perl_groups.cc re2/unicode_casefold.cc re2/unicode_groups.cc

clean:
	rm -rf obj
	rm -f re2/*.pyc

testofiles: $(TESTOFILES)

test: $(DTESTS) $(TESTS) $(STESTS) debug-test static-test shared-test

debug-test: $(DTESTS)
	@echo
	@echo Running debug binary tests.
	@echo
	@./runtests $(DTESTS)

static-test: $(TESTS)
	@echo
	@echo Running static binary tests.
	@echo
	@./runtests $(TESTS)

shared-test: $(STESTS)
	@echo
	@echo Running dynamic binary tests.
	@echo
	@LD_LIBRARY_PATH=obj/so:$(LD_LIBRARY_PATH) ./runtests $(STESTS)

debug-bigtest: $(DTESTS) $(DBIGTESTS)
	@./runtests $(DTESTS) $(DBIGTESTS)

static-bigtest: $(TESTS) $(BIGTESTS)
	@./runtests $(TESTS) $(BIGTESTS)

shared-bigtest: $(STESTS) $(SBIGTESTS)
	@LD_LIBRARY_PATH=obj/so:$(LD_LIBRARY_PATH) ./runtests $(STESTS) $(SBIGTESTS)

benchmark: obj/test/regexp_benchmark

install: obj/libre2.a obj/so/libre2.so.0
	mkdir -p $(DESTDIR)$(includedir)/re2 $(DESTDIR)$(libdir)
	$(INSTALL_DATA) $(INSTALL_HFILES) $(DESTDIR)$(includedir)/re2
	$(INSTALL) obj/libre2.a $(DESTDIR)$(libdir)/libre2.a
	$(INSTALL) obj/so/libre2.so $(DESTDIR)$(libdir)/libre2.so.$(SONAME).0.0
	ln -sf libre2.so.$(SONAME).0.0 $(DESTDIR)$(libdir)/libre2.so.$(SONAME)
	ln -sf libre2.so.$(SONAME).0.0 $(DESTDIR)$(libdir)/libre2.so

testinstall:
	@mkdir -p obj
	cp testinstall.cc obj
	(cd obj && g++ -I$(DESTDIR)$(includedir) -L$(DESTDIR)$(libdir) testinstall.cc -lre2 -pthread -o testinstall)
	LD_LIBRARY_PATH=$(DESTDIR)$(libdir) obj/testinstall

benchlog: obj/test/regexp_benchmark
	(echo '==BENCHMARK==' `hostname` `date`; \
	  (uname -a; g++ --version; hg identify; file obj/test/regexp_benchmark) | sed 's/^/# /'; \
	  echo; \
	  ./obj/test/regexp_benchmark 'PCRE|RE2') | tee -a benchlog.$$(hostname | sed 's/\..*//')

# Keep gmake from deleting intermediate files it creates.
# This makes repeated builds faster and preserves debug info on OS X.

.PRECIOUS: obj/%.o obj/dbg/%.o obj/so/%.o obj/libre2.a \
	obj/dbg/libre2.a obj/so/libre2.a \
	obj/test/% obj/so/test/% obj/dbg/test/%

=== debian/changelog ===
re2 (0+hg40+dfsg-2) experimental; urgency=low

  * Add missing Breaks and Replaces on libre2-0. (LP: #653873)
  * Fix debian/rules to allow cleaning when clean.

 -- Stefano Rivera <stefano@rivera.za.net>  Sun, 03 Oct 2010 13:39:04 +0200

re2 (0+hg40+dfsg-1) experimental; urgency=low

  * New upstream revision.
  * Upload to experimental, upstream has not committed to a stable ABI yet.
  * Drop shared library until we have a stable ABI.
  * Retire Patches:
    - destdir: Upstream Makefile now uses DESTDIR.
  * Build with Debian's valgrind header rather than embedded copy. On
    architectures where it isn't available, use an empty header instead.
  * Bump Standards-Version to 3.9.1 (no changes needed).

 -- Stefano Rivera <stefano@rivera.za.net>  Sat, 25 Sep 2010 18:18:29 +0200

re2 (0+hg23+dfsg-1) unstable; urgency=low

  * Upload to unstable.
  * New upstream revision.
  * Retired Patches:
    - shared-library: Upstream merged shared library building patch.
      Upstream now maintains exported symbol list and soname.
    - big-endian-arg-test: Improved patch merged upstream, fixing tests
      on big endian architectures.
    - pthread: Upstream merged patch to use -pthread.
    - re-generate-source: Patch merged, but table generation is optional.
      We now build with REBUILD_TABLES=1
    - noopt: We now pass CXXFLAGS from debian/rules.
    - write-barrier: Upstream merged patch to add read memory barriers.
  * New Patches:
    - local-unicodedata: Originally part of re-generate-source.
  * Correct symbols list for s390 and avr32, which have size_t as an alias for
    unsigned long.
  * Dropped 0d.0.0 soname in favour of upstream's 0.0.0.
  * Added workaround to disable --parallel when using an old debhelper.

 -- Stefano Rivera <stefano@rivera.za.net>  Sat, 01 May 2010 12:10:13 +0200

re2 (0+hg16+dfsg-1) experimental; urgency=low

  [ Stefano Rivera ]
  * Initial release. (Closes: #574276)

  [ Jakub Wilk ]
  * Add myself to uploaders.

 -- Stefano Rivera <stefano@rivera.za.net>  Sat, 10 Apr 2010 23:17:54 +0200

=== debian/control ===
Source: re2
Section: libs
Priority: optional
Maintainer: Stefano Rivera <stefano@rivera.za.net>
Uploaders: Jakub Wilk <jwilk@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~),
 libatomic-ops-dev,
 python,
 unicode-data,
 valgrind [amd64 i386 powerpc],
Standards-Version: 3.9.1
Homepage: http://code.google.com/p/re2/
Vcs-Bzr: http://bzr.debian.org/bzr/collab-maint/re2/trunk/
Vcs-Browser: http://bzr.debian.org/loggerhead/collab-maint/re2/trunk/

Package: libre2-dev
Section: libdevel
Architecture: any
Breaks: libre2-0 (<< 0+hg40+dfsg-1)
Replaces: libre2-0 (<< 0+hg40+dfsg-1)
Depends: ${misc:Depends}
Description: efficient, principled regular expression library, development kit
 RE2 is a fast, safe, thread-friendly alternative to backtracking regular
 expression engines like those used in PCRE, Perl, and Python. It is a C++
 library.
 .
 RE2 uses automata theory to guarantee that regular expression searches run in
 time linear in the size of the input. RE2 implements memory limits, so that
 searches can be constrained to a fixed amount of memory. RE2 is engineered to
 use a small fixed C++ stack footprint no matter what inputs or regular
 expressions it must process; thus RE2 is useful in multithreaded environments
 where thread stacks cannot grow arbitrarily large.
 .
 On large inputs, RE2 is often much faster than backtracking engines; its use
 of automata theory lets it apply optimizations that the others cannot.
 .
 This package contains the static library and header files used in development.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CXXFLAGS=-Wall -g -pthread -O3
else
CXXFLAGS=-Wall -g -pthread -O0
endif

ifneq ($(shell dh_testversion '<<' 7.4.10 2>/dev/null && echo old),old)
dh_parallel = --parallel
endif

%:
	dh $@ $(dh_parallel)

override_dh_auto_build:
	rm -f util/valgrind.h
	if [ -e /usr/include/valgrind/valgrind.h ]; then \
		ln -s /usr/include/valgrind/valgrind.h util; \
	else \
		touch util/valgrind.h; \
	fi
	dh_auto_build -- CXXFLAGS="$(CXXFLAGS)" REBUILD_TABLES=1

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp/ -- prefix=/usr

override_dh_clean:
	dh_clean
	rm -f util/valgrind.h

REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')

get-orig-source:
ifeq ($(REV),)
	uscan --noconf --force-download --rename --download-version=$(VER) --destdir=.
	tar -xf re2_$(VER).orig.tar.gz
	rm re2_$(VER).orig.tar.gz
else
	hg clone https://re2.googlecode.com/hg re2-$(VER)
	cd re2-$(VER) && hg up -r $(REV)
	rm -r re2-$(VER)/.hg re2-$(VER)/.hgignore
endif
	# Licensing issues
	rm -r re2-$(VER)/doc/*xkcd* re2-$(VER)/lib/codereview
	# Automatically generated code
	cd re2-$(VER)/re2 && rm perl_groups.cc unicode_casefold.cc unicode_groups.cc
	GZIP=--best tar -cz --owner root --group root --mode a+rX \
	                -f re2_$(VER)+dfsg.orig.tar.gz re2-$(VER)
	rm -r re2-$(VER)

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg// \
http://code.google.com/p/re2/downloads/list \
http://re2.googlecode.com/files/re2-(.*).tar.gz

## re2 0+hg56+dfsg

=== Makefile ===
--- 
+++ 
@@ -54,7 +54,6 @@
 	util/atomicops.h\
 	util/benchmark.h\
 	util/flags.h\
-	util/hash_map.h\
 	util/logging.h\
 	util/mutex.h\
 	util/pcre.h\

=== debian/changelog ===
re2 (0+hg56+dfsg-1) experimental; urgency=low

  * New upstream revision.
  * Update my email address.
  * Upstream has clarified their intention to not have stable releases:
    - Comment out watch file
    - Add README.Debian
  * Update copyright to latest DEP5 revision. Bump years.
  * Bump debhelper BD and compat to 8.
    - No need to check for dh --parallel support any more.
  * Use dpkg-buildflags for CXXFLAGS. Add versioned dpkg-dev BD.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 02 Feb 2011 18:09:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: re2
 Section: libs
 Priority: optional
-Maintainer: Stefano Rivera <stefano@rivera.za.net>
+Maintainer: Stefano Rivera <stefanor@debian.org>
 Uploaders: Jakub Wilk <jwilk@debian.org>
 Build-Depends:
- debhelper (>= 7.0.50~),
+ debhelper (>= 8),
+ dpkg-dev (>= 1.15.7~),
  libatomic-ops-dev,
  python,
  unicode-data,

=== debian/rules ===
--- 
+++ 
@@ -1,17 +1,9 @@
 #!/usr/bin/make -f
 
-ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-CXXFLAGS=-Wall -g -pthread -O3
-else
-CXXFLAGS=-Wall -g -pthread -O0
-endif
-
-ifneq ($(shell dh_testversion '<<' 7.4.10 2>/dev/null && echo old),old)
-dh_parallel = --parallel
-endif
+CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS | sed s/-O2/-O3/) -pthread
 
 %:
-	dh $@ $(dh_parallel)
+	dh $@ --parallel
 
 override_dh_auto_build:
 	rm -f util/valgrind.h

=== debian/watch ===
# There are no plans for stable releases:
# https://groups.google.com/group/re2-dev/browse_thread/thread/875ce4db9f11a502/7ed8799b476684a6
#version=3
#opts=dversionmangle=s/\+dfsg// \
#http://code.google.com/p/re2/downloads/list \
#http://re2.googlecode.com/files/re2-(.*).tar.gz

## re2 0+hg74+dfsg

=== debian/changelog ===
re2 (0+hg74+dfsg-1) experimental; urgency=low

  * New upstream revision.
  * Drop ia64-page-size.diff, accepted upstream.
  * Pass CPPFLAGS too.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 13 Nov 2011 01:28:52 +0200

re2 (0+hg68+dfsg-1) experimental; urgency=low

  * New upstream revision.
  * Explicitly pass CXXFLAGS and LDFLAGS to dh_auto_build and dh_auto_test,
    now that dpkg-buildpackage doesn't export anything any more.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 26 Sep 2011 00:59:05 +0200

re2 (0+hg63+dfsg-2) experimental; urgency=low

  * ia64-page-size.diff: Use multiples of 16k in re2_test.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 26 Jul 2011 17:01:30 +0200

re2 (0+hg63+dfsg-1) experimental; urgency=low

  * New upstream revision.
    - Drop include-cstddef.diff. Superseded upstream.
  * Use valgrind's header on armel and armhf too (now that it's supported
    there).

 -- Stefano Rivera <stefanor@debian.org>  Mon, 25 Jul 2011 14:19:17 +0200

re2 (0+hg57+dfsg-1) experimental; urgency=low

  * New upstream revision.
  * include-cstddef.diff: Include cstddef for compatibility with gcc 4.6.
    (LP: #770898)
  * Correct DEP3 headers (first line of Description is the subject)
  * Bump Standards-Version to 3.9.2 (no changes needed).
  * Bump copyright to latest DEP5 revision.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 29 Apr 2011 20:55:33 +0200

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,8 @@
  libatomic-ops-dev,
  python,
  unicode-data,
- valgrind [amd64 i386 powerpc],
-Standards-Version: 3.9.1
+ valgrind [amd64 armel armhf i386 powerpc]
+Standards-Version: 3.9.2
 Homepage: http://code.google.com/p/re2/
 Vcs-Bzr: http://bzr.debian.org/bzr/collab-maint/re2/trunk/
 Vcs-Browser: http://bzr.debian.org/loggerhead/collab-maint/re2/trunk/

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS | sed s/-O2/-O3/) -pthread
+LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS) -pthread
+CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
 
 %:
 	dh $@ --parallel
@@ -12,7 +14,12 @@
 	else \
 		touch util/valgrind.h; \
 	fi
-	dh_auto_build -- CXXFLAGS="$(CXXFLAGS)" REBUILD_TABLES=1
+	dh_auto_build -- CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
+	                 CPPFLAGS="$(CPPFLAGS)" REBUILD_TABLES=1
+
+override_dh_auto_test:
+	dh_auto_test -- CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
+	                CPPFLAGS="$(CPPFLAGS)"
 
 override_dh_auto_install:
 	dh_auto_install --destdir=$(CURDIR)/debian/tmp/ -- prefix=/usr

## re2 0.1.0

=== DESCRIPTION ===
Package: re2
Type: Package
Title: R Interface to Google RE2 (C++) Regular Expression Library
Version: 0.1.0
Date: 2021-04-30
Author: Girish Palya [aut, cre],
	RE2 developers [ctb] (RE2 library),
	Google Inc. [ctb, cph] (RE2 library)
Maintainer: Girish Palya <girishji@gmail.com>
Description: Pattern matching, extraction, replacement and other string
  processing operations using Google's RE2 <https://github.com/google/re2>
  regular-expression engine. Consistent interface (similar to 'stringr').
  RE2 uses finite-automata based techniques, and offers a
  fast and safe alternative to backtracking regular-expression engines
  like those used in 'stringr', 'stringi' and other PCRE implementations.
License: MIT + file LICENSE
Imports: Rcpp (>= 1.0.6)
LinkingTo: Rcpp
URL: https://github.com/girishji/re2
BugReports: https://github.com/girishji/re2/issues
Encoding: UTF-8
RoxygenNote: 7.1.1
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2021-05-02 13:47:56 UTC; gp
Repository: CRAN
Date/Publication: 2021-05-03 08:00:08 UTC

=== src/re2google/CMakeLists.txt ===
# Copyright 2015 The RE2 Authors.  All Rights Reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

# Old enough to support Ubuntu Xenial.
cmake_minimum_required(VERSION 3.5.1)

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif()

project(RE2 CXX)
include(CTest)
include(GNUInstallDirs)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

option(BUILD_SHARED_LIBS "build shared libraries" OFF)
option(USEPCRE "use PCRE in tests and benchmarks" OFF)

# CMake seems to have no way to enable/disable testing per subproject,
# so we provide an option similar to BUILD_TESTING, but just for RE2.
option(RE2_BUILD_TESTING "enable testing for RE2" ON)

# ABI version
# http://tldp.org/HOWTO/Program-Library-HOWTO/shared-libraries.html
set(SONAME 9)

set(EXTRA_TARGET_LINK_LIBRARIES)

if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  if(MSVC_VERSION LESS 1900)
    message(FATAL_ERROR "you need Visual Studio 2015 or later")
  endif()
  if(BUILD_SHARED_LIBS)
    # See http://www.kitware.com/blog/home/post/939 for details.
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
  endif()
  # CMake defaults to /W3, but some users like /W4 (or /Wall) and /WX,
  # so we disable various warnings that aren't particularly helpful.
  add_compile_options(/wd4100 /wd4201 /wd4456 /wd4457 /wd4702 /wd4815)
  # Without a byte order mark (BOM), Visual Studio assumes that the source
  # file is encoded using the current user code page, so we specify UTF-8.
  add_compile_options(/utf-8)
endif()

if(WIN32)
  add_definitions(-DUNICODE -D_UNICODE -DSTRICT -DNOMINMAX)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
elseif(UNIX)
  add_compile_options(-pthread)
  list(APPEND EXTRA_TARGET_LINK_LIBRARIES -pthread)
endif()

if(USEPCRE)
  add_definitions(-DUSEPCRE)
  list(APPEND EXTRA_TARGET_LINK_LIBRARIES pcre)
endif()

set(RE2_SOURCES
    re2/bitstate.cc
    re2/compile.cc
    re2/dfa.cc
    re2/filtered_re2.cc
    re2/mimics_pcre.cc
    re2/nfa.cc
    re2/onepass.cc
    re2/parse.cc
    re2/perl_groups.cc
    re2/prefilter.cc
    re2/prefilter_tree.cc
    re2/prog.cc
    re2/re2.cc
    re2/regexp.cc
    re2/set.cc
    re2/simplify.cc
    re2/stringpiece.cc
    re2/tostring.cc
    re2/unicode_casefold.cc
    re2/unicode_groups.cc
    util/rune.cc
    util/strutil.cc
    )

add_library(re2 ${RE2_SOURCES})
target_include_directories(re2 PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
set_target_properties(re2 PROPERTIES SOVERSION ${SONAME} VERSION ${SONAME}.0.0)
add_library(re2::re2 ALIAS re2)

if(RE2_BUILD_TESTING)
  set(TESTING_SOURCES
      re2/testing/backtrack.cc
      re2/testing/dump.cc
      re2/testing/exhaustive_tester.cc
      re2/testing/null_walker.cc
      re2/testing/regexp_generator.cc
      re2/testing/string_generator.cc
      re2/testing/tester.cc
      util/pcre.cc
      )

  add_library(testing STATIC ${TESTING_SOURCES})
  target_link_libraries(testing PUBLIC re2)

  set(TEST_TARGETS
      charclass_test
      compile_test
      filtered_re2_test
      mimics_pcre_test
      parse_test
      possible_match_test
      re2_test
      re2_arg_test
      regexp_test
      required_prefix_test
      search_test
      set_test
      simplify_test
      string_generator_test

      dfa_test
      exhaustive1_test
      exhaustive2_test
      exhaustive3_test
      exhaustive_test
      random_test
      )

  set(BENCHMARK_TARGETS
      regexp_benchmark
      )

  foreach(target ${TEST_TARGETS})
    add_executable(${target} re2/testing/${target}.cc util/test.cc)
    target_link_libraries(${target} testing ${EXTRA_TARGET_LINK_LIBRARIES})
    add_test(NAME ${target} COMMAND ${target})
  endforeach(target)

  foreach(target ${BENCHMARK_TARGETS})
    add_executable(${target} re2/testing/${target}.cc util/benchmark.cc)
    target_link_libraries(${target} testing ${EXTRA_TARGET_LINK_LIBRARIES})
  endforeach(target)
endif()

set(RE2_HEADERS
    re2/filtered_re2.h
    re2/re2.h
    re2/set.h
    re2/stringpiece.h
    )

install(FILES ${RE2_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/re2)
install(TARGETS re2 EXPORT re2Config
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT re2Config
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/re2 NAMESPACE re2::)

## re2 0.1.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: re2
 Type: Package
 Title: R Interface to Google RE2 (C++) Regular Expression Library
-Version: 0.1.0
+Version: 0.1.1
 Date: 2021-04-30
 Author: Girish Palya [aut, cre],
 	RE2 developers [ctb] (RE2 library),
@@ -23,6 +23,6 @@
 Suggests: knitr, rmarkdown
 VignetteBuilder: knitr
 NeedsCompilation: yes
-Packaged: 2021-05-02 13:47:56 UTC; gp
+Packaged: 2021-05-11 19:51:19 UTC; gp
 Repository: CRAN
-Date/Publication: 2021-05-03 08:00:08 UTC
+Date/Publication: 2021-05-12 23:00:12 UTC

## re2 0.1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: re2
 Type: Package
 Title: R Interface to Google RE2 (C++) Regular Expression Library
-Version: 0.1.1
-Date: 2021-04-30
+Version: 0.1.2
+Date: 2022-03-29
 Author: Girish Palya [aut, cre],
 	RE2 developers [ctb] (RE2 library),
 	Google Inc. [ctb, cph] (RE2 library)
@@ -14,15 +14,15 @@
   fast and safe alternative to backtracking regular-expression engines
   like those used in 'stringr', 'stringi' and other PCRE implementations.
 License: MIT + file LICENSE
-Imports: Rcpp (>= 1.0.6)
+Imports: Rcpp (>= 1.0.8.3)
 LinkingTo: Rcpp
 URL: https://github.com/girishji/re2
 BugReports: https://github.com/girishji/re2/issues
 Encoding: UTF-8
-RoxygenNote: 7.1.1
+RoxygenNote: 7.1.2
 Suggests: knitr, rmarkdown
 VignetteBuilder: knitr
 NeedsCompilation: yes
-Packaged: 2021-05-11 19:51:19 UTC; gp
+Packaged: 2022-03-29 08:30:43 UTC; gp
 Repository: CRAN
-Date/Publication: 2021-05-12 23:00:12 UTC
+Date/Publication: 2022-03-29 11:50:02 UTC

## re2 0.1.3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: re2
 Type: Package
 Title: R Interface to Google RE2 (C++) Regular Expression Library
-Version: 0.1.2
-Date: 2022-03-29
+Version: 0.1.3
+Date: 2023-11-28
 Author: Girish Palya [aut, cre],
 	RE2 developers [ctb] (RE2 library),
 	Google Inc. [ctb, cph] (RE2 library)
@@ -19,10 +19,10 @@
 URL: https://github.com/girishji/re2
 BugReports: https://github.com/girishji/re2/issues
 Encoding: UTF-8
-RoxygenNote: 7.1.2
+RoxygenNote: 7.2.3
 Suggests: knitr, rmarkdown
 VignetteBuilder: knitr
 NeedsCompilation: yes
-Packaged: 2022-03-29 08:30:43 UTC; gp
+Packaged: 2023-11-29 00:26:02 UTC; gp
 Repository: CRAN
-Date/Publication: 2022-03-29 11:50:02 UTC
+Date/Publication: 2023-11-29 03:10:02 UTC

## re2 0.1.4

=== DESCRIPTION ===
Package: re2
Type: Package
Title: R Interface to Google RE2 (C++) Regular Expression Library
Version: 0.1.4
Date: 2025-01-11
Authors@R: c(person(given = "Girish",
                      family = "Palya",
                      role = c("aut", "cre"),
                      email = "girishji@gmail.com"),
               person("RE2 developers",
                      role = "ctb",
                      comment = "RE2 library"),
               person("Google Inc.",
                      role = c("ctb", "cph"),
                      comment = "RE2 library"))
Description: Pattern matching, extraction, replacement and other string
  processing operations using Google's RE2 <https://github.com/google/re2>
  regular-expression engine. Consistent interface (similar to 'stringr').
  RE2 uses finite-automata based techniques, and offers a
  fast and safe alternative to backtracking regular-expression engines
  like those used in 'stringr', 'stringi' and other PCRE implementations.
License: MIT + file LICENSE
Imports: Rcpp (>= 1.0.8.3)
LinkingTo: Rcpp
URL: https://github.com/girishji/re2
BugReports: https://github.com/girishji/re2/issues
Encoding: UTF-8
RoxygenNote: 7.3.2
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2025-01-19 22:14:31 UTC; gp
Author: Girish Palya [aut, cre],
  RE2 developers [ctb] (RE2 library),
  Google Inc. [ctb, cph] (RE2 library)
Maintainer: Girish Palya <girishji@gmail.com>
Repository: CRAN
Date/Publication: 2025-01-19 22:40:02 UTC

## re2 2023.08.01

=== Makefile ===
# Copyright 2009 The RE2 Authors.  All Rights Reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

# Build against Abseil.
ABSL_DEPS=\
	absl_base\
	absl_core_headers\
	absl_fixed_array\
	absl_flags\
	absl_flat_hash_map\
	absl_flat_hash_set\
	absl_inlined_vector\
	absl_optional\
	absl_span\
	absl_str_format\
	absl_strings\
	absl_synchronization\

CCABSL=$(shell pkg-config $(ABSL_DEPS) --cflags)
# GCC barfs on `-Wl` whereas Clang doesn't mind, but it's unclear what
# causes it to manifest on Ubuntu 22.04 LTS, so filter it out for now.
LDABSL=$(shell pkg-config $(ABSL_DEPS) --libs | sed -e 's/-Wl / /g')

# To build against ICU for full Unicode properties support,
# uncomment the next two lines:
# CCICU=$(shell pkg-config icu-uc --cflags) -DRE2_USE_ICU
# LDICU=$(shell pkg-config icu-uc --libs)

# To build against PCRE for testing and benchmarking,
# uncomment the next two lines:
# CCPCRE=-I/usr/local/include -DUSEPCRE
# LDPCRE=-L/usr/local/lib -lpcre

CXX?=g++
# can override
CXXFLAGS?=-O3 -g
LDFLAGS?=
# required
RE2_CXXFLAGS?=-pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -I. $(CCABSL) $(CCICU) $(CCPCRE)
RE2_LDFLAGS?=-pthread $(LDABSL) $(LDICU) $(LDPCRE)
AR?=ar
ARFLAGS?=rsc
NM?=nm
NMFLAGS?=-p

# Variables mandated by GNU, the arbiter of all good taste on the internet.
# http://www.gnu.org/prep/standards/standards.html
prefix=/usr/local
exec_prefix=$(prefix)
includedir=$(prefix)/include
libdir=$(exec_prefix)/lib
INSTALL=install
INSTALL_DATA=$(INSTALL) -m 644

# Work around the weirdness of sed(1) on Darwin. :/
ifeq ($(shell uname),Darwin)
SED_INPLACE=sed -i ''
else ifeq ($(shell uname),SunOS)
SED_INPLACE=sed -i
else
SED_INPLACE=sed -i
endif

# The pkg-config Requires: field.
REQUIRES=$(ABSL_DEPS)
ifdef LDICU
REQUIRES+=icu-uc
endif

# ABI version
# http://tldp.org/HOWTO/Program-Library-HOWTO/shared-libraries.html
SONAME=11

# To rebuild the Tables generated by Perl and Python scripts (requires Internet
# access for Unicode data), uncomment the following line:
# REBUILD_TABLES=1

# The SunOS linker does not support wildcards. :(
ifeq ($(shell uname),Darwin)
SOEXT=dylib
SOEXTVER=$(SONAME).$(SOEXT)
SOEXTVER00=$(SONAME).0.0.$(SOEXT)
MAKE_SHARED_LIBRARY=$(CXX) -dynamiclib -Wl,-compatibility_version,$(SONAME),-current_version,$(SONAME).0.0,-install_name,$(libdir)/libre2.$(SOEXTVER),-exported_symbols_list,libre2.symbols.darwin
else ifeq ($(shell uname),SunOS)
SOEXT=so
SOEXTVER=$(SOEXT).$(SONAME)
SOEXTVER00=$(SOEXT).$(SONAME).0.0
MAKE_SHARED_LIBRARY=$(CXX) -shared -Wl,-soname,libre2.$(SOEXTVER)
else
SOEXT=so
SOEXTVER=$(SOEXT).$(SONAME)
SOEXTVER00=$(SOEXT).$(SONAME).0.0
MAKE_SHARED_LIBRARY=$(CXX) -shared -Wl,-soname,libre2.$(SOEXTVER),--version-script,libre2.symbols
endif

.PHONY: all
all: obj/libre2.a obj/so/libre2.$(SOEXT)

INSTALL_HFILES=\
	re2/filtered_re2.h\
	re2/re2.h\
	re2/set.h\
	re2/stringpiece.h\

HFILES=\
	util/logging.h\
	util/malloc_counter.h\
	util/pcre.h\
	util/strutil.h\
	util/utf.h\
	re2/bitmap256.h\
	re2/filtered_re2.h\
	re2/pod_array.h\
	re2/prefilter.h\
	re2/prefilter_tree.h\
	re2/prog.h\
	re2/re2.h\
	re2/regexp.h\
	re2/set.h\
	re2/sparse_array.h\
	re2/sparse_set.h\
	re2/stringpiece.h\
	re2/testing/exhaustive_tester.h\
	re2/testing/regexp_generator.h\
	re2/testing/string_generator.h\
	re2/testing/tester.h\
	re2/unicode_casefold.h\
	re2/unicode_groups.h\
	re2/walker-inl.h\

OFILES=\
	obj/util/rune.o\
	obj/util/strutil.o\
	obj/re2/bitmap256.o\
	obj/re2/bitstate.o\
	obj/re2/compile.o\
	obj/re2/dfa.o\
	obj/re2/filtered_re2.o\
	obj/re2/mimics_pcre.o\
	obj/re2/nfa.o\
	obj/re2/onepass.o\
	obj/re2/parse.o\
	obj/re2/perl_groups.o\
	obj/re2/prefilter.o\
	obj/re2/prefilter_tree.o\
	obj/re2/prog.o\
	obj/re2/re2.o\
	obj/re2/regexp.o\
	obj/re2/set.o\
	obj/re2/simplify.o\
	obj/re2/tostring.o\
	obj/re2/unicode_casefold.o\
	obj/re2/unicode_groups.o\

TESTOFILES=\
	obj/util/pcre.o\
	obj/re2/testing/backtrack.o\
	obj/re2/testing/dump.o\
	obj/re2/testing/exhaustive_tester.o\
	obj/re2/testing/null_walker.o\
	obj/re2/testing/regexp_generator.o\
	obj/re2/testing/string_generator.o\
	obj/re2/testing/tester.o\

TESTS=\
	obj/test/charclass_test\
	obj/test/compile_test\
	obj/test/filtered_re2_test\
	obj/test/mimics_pcre_test\
	obj/test/parse_test\
	obj/test/possible_match_test\
	obj/test/re2_test\
	obj/test/re2_arg_test\
	obj/test/regexp_test\
	obj/test/required_prefix_test\
	obj/test/search_test\
	obj/test/set_test\
	obj/test/simplify_test\
	obj/test/string_generator_test\

BIGTESTS=\
	obj/test/dfa_test\
	obj/test/exhaustive1_test\
	obj/test/exhaustive2_test\
	obj/test/exhaustive3_test\
	obj/test/exhaustive_test\
	obj/test/random_test\

SOFILES=$(patsubst obj/%,obj/so/%,$(OFILES))
# We use TESTOFILES for testing the shared lib, only it is built differently.
STESTS=$(patsubst obj/%,obj/so/%,$(TESTS))
SBIGTESTS=$(patsubst obj/%,obj/so/%,$(BIGTESTS))

DOFILES=$(patsubst obj/%,obj/dbg/%,$(OFILES))
DTESTOFILES=$(patsubst obj/%,obj/dbg/%,$(TESTOFILES))
DTESTS=$(patsubst obj/%,obj/dbg/%,$(TESTS))
DBIGTESTS=$(patsubst obj/%,obj/dbg/%,$(BIGTESTS))

.PRECIOUS: obj/%.o
obj/%.o: %.cc $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CXX) -c -o $@ $(CPPFLAGS) $(RE2_CXXFLAGS) $(CXXFLAGS) -DNDEBUG $*.cc

.PRECIOUS: obj/dbg/%.o
obj/dbg/%.o: %.cc $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CXX) -c -o $@ $(CPPFLAGS) $(RE2_CXXFLAGS) $(CXXFLAGS) $*.cc

.PRECIOUS: obj/so/%.o
obj/so/%.o: %.cc $(HFILES)
	@mkdir -p $$(dirname $@)
	$(CXX) -c -o $@ -fPIC $(CPPFLAGS) $(RE2_CXXFLAGS) $(CXXFLAGS) -DNDEBUG $*.cc

.PRECIOUS: obj/libre2.a
obj/libre2.a: $(OFILES)
	@mkdir -p obj
	$(AR) $(ARFLAGS) obj/libre2.a $(OFILES)

.PRECIOUS: obj/dbg/libre2.a
obj/dbg/libre2.a: $(DOFILES)
	@mkdir -p obj/dbg
	$(AR) $(ARFLAGS) obj/dbg/libre2.a $(DOFILES)

.PRECIOUS: obj/so/libre2.$(SOEXT)
obj/so/libre2.$(SOEXT): $(SOFILES) libre2.symbols libre2.symbols.darwin
	@mkdir -p obj/so
	$(MAKE_SHARED_LIBRARY) -o obj/so/libre2.$(SOEXTVER) $(SOFILES) $(RE2_LDFLAGS) $(LDFLAGS)
	ln -sf libre2.$(SOEXTVER) $@

.PRECIOUS: obj/dbg/test/%
obj/dbg/test/%: obj/dbg/libre2.a obj/dbg/re2/testing/%.o $(DTESTOFILES)
	@mkdir -p obj/dbg/test
	$(CXX) -o $@ obj/dbg/re2/testing/$*.o $(DTESTOFILES) -lgtest -lgtest_main obj/dbg/libre2.a $(RE2_LDFLAGS) $(LDFLAGS)

.PRECIOUS: obj/test/%
obj/test/%: obj/libre2.a obj/re2/testing/%.o $(TESTOFILES)
	@mkdir -p obj/test
	$(CXX) -o $@ obj/re2/testing/$*.o $(TESTOFILES) -lgtest -lgtest_main obj/libre2.a $(RE2_LDFLAGS) $(LDFLAGS)

# Test the shared lib, falling back to the static lib for private symbols
.PRECIOUS: obj/so/test/%
obj/so/test/%: obj/so/libre2.$(SOEXT) obj/libre2.a obj/re2/testing/%.o $(TESTOFILES)
	@mkdir -p obj/so/test
	$(CXX) -o $@ obj/re2/testing/$*.o $(TESTOFILES) -lgtest -lgtest_main -Lobj/so -lre2 obj/libre2.a $(RE2_LDFLAGS) $(LDFLAGS)

obj/test/regexp_benchmark: obj/libre2.a obj/re2/testing/regexp_benchmark.o $(TESTOFILES)
	@mkdir -p obj/test
	$(CXX) -o $@ obj/re2/testing/regexp_benchmark.o $(TESTOFILES) -lgtest -lbenchmark -lbenchmark_main obj/libre2.a $(RE2_LDFLAGS) $(LDFLAGS)

# re2_fuzzer is a target for fuzzers like libFuzzer and AFL. This fake fuzzing
# is simply a way to check that the target builds and then to run it against a
# fixed set of inputs. To perform real fuzzing, refer to the documentation for
# libFuzzer (llvm.org/docs/LibFuzzer.html) and AFL (lcamtuf.coredump.cx/afl/).
obj/test/re2_fuzzer: CXXFLAGS:=-I./re2/fuzzing/compiler-rt/include $(CXXFLAGS)
obj/test/re2_fuzzer: obj/libre2.a obj/re2/fuzzing/re2_fuzzer.o obj/util/fuzz.o
	@mkdir -p obj/test
	$(CXX) -o $@ obj/re2/fuzzing/re2_fuzzer.o obj/util/fuzz.o obj/libre2.a $(RE2_LDFLAGS) $(LDFLAGS)

ifdef REBUILD_TABLES
.PRECIOUS: re2/perl_groups.cc
re2/perl_groups.cc: re2/make_perl_groups.pl
	perl $< > $@

.PRECIOUS: re2/unicode_%.cc
re2/unicode_%.cc: re2/make_unicode_%.py re2/unicode.py
	python3 $< > $@
endif

.PHONY: distclean
distclean: clean
	rm -f re2/perl_groups.cc re2/unicode_casefold.cc re2/unicode_groups.cc

.PHONY: clean
clean:
	rm -rf obj
	rm -f re2/*.pyc

.PHONY: testofiles
testofiles: $(TESTOFILES)

.PHONY: test
test: $(DTESTS) $(TESTS) $(STESTS) debug-test static-test shared-test

.PHONY: debug-test
debug-test: $(DTESTS)
	@./runtests $(DTESTS)

.PHONY: static-test
static-test: $(TESTS)
	@./runtests $(TESTS)

.PHONY: shared-test
shared-test: $(STESTS)
	@./runtests -shared-library-path obj/so $(STESTS)

.PHONY: debug-bigtest
debug-bigtest: $(DTESTS) $(DBIGTESTS)
	@./runtests $(DTESTS) $(DBIGTESTS)

.PHONY: static-bigtest
static-bigtest: $(TESTS) $(BIGTESTS)
	@./runtests $(TESTS) $(BIGTESTS)

.PHONY: shared-bigtest
shared-bigtest: $(STESTS) $(SBIGTESTS)
	@./runtests -shared-library-path obj/so $(STESTS) $(SBIGTESTS)

.PHONY: benchmark
benchmark: obj/test/regexp_benchmark

.PHONY: fuzz
fuzz: obj/test/re2_fuzzer

.PHONY: install
install: static-install shared-install

.PHONY: static
static: obj/libre2.a

.PHONY: static-install
static-install: obj/libre2.a common-install
	$(INSTALL) obj/libre2.a $(DESTDIR)$(libdir)/libre2.a

.PHONY: shared
shared: obj/so/libre2.$(SOEXT)

.PHONY: shared-install
shared-install: obj/so/libre2.$(SOEXT) common-install
	$(INSTALL) obj/so/libre2.$(SOEXT) $(DESTDIR)$(libdir)/libre2.$(SOEXTVER00)
	ln -sf libre2.$(SOEXTVER00) $(DESTDIR)$(libdir)/libre2.$(SOEXTVER)
	ln -sf libre2.$(SOEXTVER00) $(DESTDIR)$(libdir)/libre2.$(SOEXT)

.PHONY: common-install
common-install:
	mkdir -p $(DESTDIR)$(includedir)/re2 $(DESTDIR)$(libdir)/pkgconfig
	$(INSTALL_DATA) $(INSTALL_HFILES) $(DESTDIR)$(includedir)/re2
	$(INSTALL_DATA) re2.pc.in $(DESTDIR)$(libdir)/pkgconfig/re2.pc
	$(SED_INPLACE) -e "s#@CMAKE_INSTALL_FULL_INCLUDEDIR@#$(includedir)#" $(DESTDIR)$(libdir)/pkgconfig/re2.pc
	$(SED_INPLACE) -e "s#@CMAKE_INSTALL_FULL_LIBDIR@#$(libdir)#" $(DESTDIR)$(libdir)/pkgconfig/re2.pc
	$(SED_INPLACE) -e "s#@REQUIRES@#$(REQUIRES)#" $(DESTDIR)$(libdir)/pkgconfig/re2.pc
	$(SED_INPLACE) -e "s#@SONAME@#$(SONAME)#" $(DESTDIR)$(libdir)/pkgconfig/re2.pc

.PHONY: testinstall
testinstall: static-testinstall shared-testinstall
	@echo
	@echo Install tests passed.
	@echo

.PHONY: static-testinstall
static-testinstall:
ifeq ($(shell uname),Darwin)
	@echo Skipping test for libre2.a on Darwin.
else ifeq ($(shell uname),SunOS)
	@echo Skipping test for libre2.a on SunOS.
else
	@mkdir -p obj
	@cp testinstall.cc obj/static-testinstall.cc
	(cd obj && export PKG_CONFIG_PATH=$(DESTDIR)$(libdir)/pkgconfig; \
	  $(CXX) static-testinstall.cc -o static-testinstall $(CXXFLAGS) $(LDFLAGS) \
	  $$(pkg-config re2 --cflags --libs | sed -e 's/-lre2/-l:libre2.a/'))
	obj/static-testinstall
endif

.PHONY: shared-testinstall
shared-testinstall:
	@mkdir -p obj
	@cp testinstall.cc obj/shared-testinstall.cc
	(cd obj && export PKG_CONFIG_PATH=$(DESTDIR)$(libdir)/pkgconfig; \
	  $(CXX) shared-testinstall.cc -o shared-testinstall $(CXXFLAGS) $(LDFLAGS) \
	  $$(pkg-config re2 --cflags --libs))
ifeq ($(shell uname),Darwin)
	DYLD_LIBRARY_PATH="$(DESTDIR)$(libdir):$(DYLD_LIBRARY_PATH)" obj/shared-testinstall
else
	LD_LIBRARY_PATH="$(DESTDIR)$(libdir):$(LD_LIBRARY_PATH)" obj/shared-testinstall
endif

.PHONY: benchlog
benchlog: obj/test/regexp_benchmark
	(echo '==BENCHMARK==' `hostname` `date`; \
	  (uname -a; $(CXX) --version; git rev-parse --short HEAD; file obj/test/regexp_benchmark) | sed 's/^/# /'; \
	  echo; \
	  ./obj/test/regexp_benchmark 'PCRE|RE2') | tee -a benchlog.$$(hostname | sed 's/\..*//')

.PHONY: log
log:
	$(MAKE) clean
	$(MAKE) CXXFLAGS="$(CXXFLAGS) -DLOGGING=1" \
		$(filter obj/test/exhaustive%_test,$(BIGTESTS))
	echo '#' RE2 exhaustive tests built by make log >re2-exhaustive.txt
	echo '#' $$(date) >>re2-exhaustive.txt
	obj/test/exhaustive_test |grep -v '^PASS$$' >>re2-exhaustive.txt
	obj/test/exhaustive1_test |grep -v '^PASS$$' >>re2-exhaustive.txt
	obj/test/exhaustive2_test |grep -v '^PASS$$' >>re2-exhaustive.txt
	obj/test/exhaustive3_test |grep -v '^PASS$$' >>re2-exhaustive.txt

	$(MAKE) CXXFLAGS="$(CXXFLAGS) -DLOGGING=1" obj/test/search_test

=== debian/changelog ===
re2 (2023.08.01-1) experimental; urgency=medium

  * New upstream release.

 -- Valdur Palm <vpalm@perforce.com>  Thu, 31 Aug 2023 09:00:11 +0300

=== debian/control ===
Source: re2
Section: devel
Priority: optional
Maintainer: Valdur Palm <vpalm@perforce.com>
Build-Depends: debhelper, cmake (>=3.13) | base-files (<=10.2), ninja-build, build-essential, libicu-dev, libabsl-zendphp-dev
Build-Depends-Indep:

Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/google/re2
Package: libre2-11-zendphp
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libabsl-zendphp
Description: Efficient, principled regular expression library. Built for ZendPHP.

Package: libre2-zendphp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Conflicts: libre2-dev
Depends: ${misc:Depends}, libre2-11-zendphp (= ${binary:Version}), libicu-dev, libabsl-zendphp-dev
Description: Efficient, principled regular expression library. Built for ZendPHP (development files)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export GEM2DEB_TEST_RUNNER = --check-dependencies
# Note - ALSO .install,.docs file names and control content for package and dev deps need to be changed
SONAME=11
API_VERSION=$(SONAME)-0

PACKAGEVERSION = $(shell debian/get_ver.sh 'libre2-$(SONAME)-zendphp' '2023.08.01')

%:
	dh $@

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
override_dh_auto_configure:
	dpkg-architecture -f -a$(DEB_BUILD_ARCH) -c dh_auto_configure

endif

PREFIX		  = /opt/zend/zendphp

override_dh_auto_configure:
	ActSO=$(grep '^SONAME=' Makefile|cut -d '=' -f 2)
	$(call assert,$(call sne, $(SONAME),$(ActSO))SONAME $(ActSO) from Makefile is not equal to $(SONAME) in rules and control. Please change)
	export LDFLAGS= ; \
	export CFLAGS= ; \
	export CPPFLAGS= ; \
	export CXXFLAGS= ; \
	cmake . \
		-G Ninja \
		-DCMAKE_INSTALL_PREFIX=${PREFIX} \
		-DCMAKE_PREFIX_PATH=${PREFIX} \
		-DBUILD_STATIC_LIBS=ON \
		-DCMAKE_CXX_STANDARD=17 \
		-DCMAKE_BUILD_TYPE=MinSizeRel \
		-DRE2_USE_ICU=ON \
		-DCMAKE_INSTALL_LIBDIR=lib \
		-DCMAKE_POSITION_INDEPENDENT_CODE=ON \
		-DCMAKE_INSTALL_RPATH="${PREFIX}/lib"

override_dh_auto_build:
	cmake --build .

override_dh_auto_clean:
	rm -rf build || true

override_dh_auto_test:
	:

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp ninja install
	mkdir -p $(CURDIR)/debian/tmp/usr/lib
	mv $(CURDIR)/debian/tmp/$(PREFIX)/lib/pkgconfig $(CURDIR)/debian/tmp/usr/lib
	dh_install

override_dh_installdocs:
	dh_installdocs

override_dh_gencontrol:
	dh_gencontrol -- -v$(PACKAGEVERSION)

override_dh_dwz:
	echo GCC bug

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -l$(CURDIR)/debian/tmp/$(PREFIX)/lib -l$(PREFIX)/lib

#override_dh_usrlocal:
#	echo Skip processing /usr/local

=== debian/watch ===
version=4
opts=uversionmangle=s/-?(beta)-?/~$1/;s/-?(alpha)-?/~$1/;s/-?(rc)-?/~rc/ \
https://github.com/google/re2/releases \
.*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|zeromq(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
